package com.engine.jhsecond.web;

import com.alibaba.fastjson.JSONObject;
import com.engine.common.util.ParamUtil;
import com.engine.common.util.ServiceUtil;
import com.engine.jhsecond.service.OrganizationChartService;
import com.engine.jhsecond.service.impl.OrganizationChartServiceImpl;
import weaver.hrm.HrmUserVarify;
import weaver.hrm.User;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.ws.rs.GET;
import javax.ws.rs.Path;
import javax.ws.rs.Produces;
import javax.ws.rs.core.Context;
import javax.ws.rs.core.MediaType;
import java.util.HashMap;
import java.util.Map;

/**
 * @Author liang.cheng
 * @Date 2024/7/16 5:15 PM
 * @Description: nbjh组织架构图
 * @Version 1.0
 */
public class OrganizationChartAction {

    private OrganizationChartService getOrganizationChartService(User user) {
        return ServiceUtil.getService(OrganizationChartServiceImpl.class,user);
    }


    @GET
    @Path("/selectData")
    @Produces(MediaType.APPLICATION_JSON)
    public String selectData(@Context HttpServletRequest request, @Context HttpServletResponse response) {
        Map<String, Object> apidatas = new HashMap<>(4);
        try {
            User user = HrmUserVarify.getUser(request, response);
            apidatas = getOrganizationChartService(user).selectData(ParamUtil.request2Map(request));
            apidatas.put("api_status", true);
        } catch (Exception e) {
            apidatas.put("api_status", false);
        }
        return JSONObject.toJSONString(apidatas);
    }
}
